﻿namespace TabsStudioXMenu
{
    class CommandInfo
    {
        public CommandInfo(EnvDTE80.DTE2 dte_)
        {
            dte = dte_;
            System.IServiceProvider serviceProvider = new Microsoft.VisualStudio.Shell.ServiceProvider(
                dte as Microsoft.VisualStudio.OLE.Interop.IServiceProvider);
            if (serviceProvider != null)
            {
                hostCommandDispatcher = serviceProvider.GetService(
                    typeof(Microsoft.VisualStudio.Shell.Interop.SUIHostCommandDispatcher)) as
                        Microsoft.VisualStudio.OLE.Interop.IOleCommandTarget;
            }
        }

        public CommandStatus GetCommandStatus(Microsoft.VisualStudio.CommandBars.CommandBarControl c)
        {
            OLECMDFWrapper status = QueryStatus(c);
            if (status != null)
            {
                return new CommandStatus(status.IsSupported() && !status.IsInvisible() && !status.IsDefHide(),
                    status.IsEnabled(), status.IsLatched());
            }
            return new CommandStatus(c.Visible, c.Enabled, false);
        }

        public string GetCommandName(Microsoft.VisualStudio.CommandBars.CommandBarControl c)
        {
            return GetCommand(c).Name;
        }

        private EnvDTE.Command GetCommand(Microsoft.VisualStudio.CommandBars.CommandBarControl c)
        {
            string guid;
            int id;
            dte.Commands.CommandInfo(c, out guid, out id);
            return dte.Commands.Item(guid, id);
        }

        private OLECMDFWrapper QueryStatus(Microsoft.VisualStudio.CommandBars.CommandBarControl c)
        {
            if (hostCommandDispatcher != null)
            {
                EnvDTE.Command command = GetCommand(c);
                Microsoft.VisualStudio.OLE.Interop.OLECMD olecmd = new Microsoft.VisualStudio.OLE.Interop.OLECMD();
                olecmd.cmdID = (uint)command.ID;
                Microsoft.VisualStudio.OLE.Interop.OLECMD[] olecmds = { olecmd };
                System.Guid guid = new System.Guid(command.Guid);
                System.IntPtr text = new System.IntPtr();
                if (hostCommandDispatcher.QueryStatus(ref guid, 1, olecmds, text) == Microsoft.VisualStudio.VSConstants.S_OK)
                    return new OLECMDFWrapper((Microsoft.VisualStudio.OLE.Interop.OLECMDF)olecmds[0].cmdf);
            }
            return null;
        }

        private EnvDTE80.DTE2 dte;
        private Microsoft.VisualStudio.OLE.Interop.IOleCommandTarget hostCommandDispatcher;
    }
}
