﻿namespace TabsStudioXMenu
{
    class StdOLEHelper
    {
        public static System.Windows.Controls.Image PictureToImage(stdole.StdPicture picture, stdole.StdPicture mask)
        {
            if (picture == null)
                return null;

            System.Drawing.Bitmap pictureBitmap = AxHostConverter.PictureFromIPicture(picture) as System.Drawing.Bitmap;
            if (pictureBitmap == null)
                return null;

            if (mask == null)
            {
                return DrawingImageToWPFImage(pictureBitmap);
            }
            else
            {
                System.Drawing.Bitmap maskBitmap = AxHostConverter.PictureFromIPicture(mask) as System.Drawing.Bitmap;
                if (maskBitmap == null)
                    return DrawingImageToWPFImage(pictureBitmap);
                else
                    return DrawingImageToWPFImage(ApplyMask(pictureBitmap, maskBitmap));
            }
        }

        public static System.Windows.Controls.Image PictureToImage(stdole.StdPicture picture)
        {
            if (picture == null)
                return null;

            System.Drawing.Bitmap pictureBitmap = IPictureDispConverter.ConvertPixelByPixel(picture as stdole.IPictureDisp);
            if (pictureBitmap == null)
                return null;

            return DrawingImageToWPFImage(pictureBitmap);
        }

        private static System.Windows.Controls.Image DrawingImageToWPFImage(System.Drawing.Image image)
        {
            System.IO.MemoryStream ms = new System.IO.MemoryStream();
            image.Save(ms, System.Drawing.Imaging.ImageFormat.Png);

            System.Windows.Media.Imaging.BitmapImage bitmap = new System.Windows.Media.Imaging.BitmapImage();
            bitmap.BeginInit();
            bitmap.StreamSource = ms;
            bitmap.EndInit();

            System.Windows.Controls.Image result = new System.Windows.Controls.Image();
            result.Source = bitmap;
            return result;
        }

        private static System.Drawing.Bitmap ApplyMask(System.Drawing.Bitmap picture, System.Drawing.Bitmap mask)
        {
            System.Drawing.Bitmap result = new System.Drawing.Bitmap(picture.Width, picture.Height,
                    System.Drawing.Imaging.PixelFormat.Format32bppArgb);
            using (System.Drawing.Graphics g = System.Drawing.Graphics.FromImage(result))
            {
                System.Drawing.Rectangle rect = new System.Drawing.Rectangle(0, 0, picture.Width, picture.Height);
                g.DrawImage(picture, rect);
            }
            for (int x = 0; x < picture.Width && x < mask.Width; ++x)
            {
                for (int y = 0; y < picture.Height && y < mask.Height; ++y)
                {
                    System.Drawing.Color c = mask.GetPixel(x, y);
                    if (!(c.R == 0 && c.G == 0 && c.B == 0))
                        result.SetPixel(x, y, System.Drawing.Color.FromArgb(0, picture.GetPixel(x, y)));
                }
            }
           return result;
        }
    }
}
